diff --git a/doc/guides/cryptodevs/ccp.rst b/doc/guides/cryptodevs/ccp.rst
index 36dae090f9..52e98b0859 100644
--- a/doc/guides/cryptodevs/ccp.rst
+++ b/doc/guides/cryptodevs/ccp.rst
@@ -100,7 +100,7 @@ The following parameters (all optional) can be provided in the previous two call
 
 * ccp_auth_opt: Specify authentication operations to perform on CPU using openssl APIs.
 
-To validate ccp pmd, l2fwd-crypto example can be used with following command:
+To validate ccp PMD, l2fwd-crypto example can be used with following command:
 
 .. code-block:: console
 
diff --git a/doc/guides/cryptodevs/openssl.rst b/doc/guides/cryptodevs/openssl.rst
index 848a2e8eb8..03041ceda1 100644
--- a/doc/guides/cryptodevs/openssl.rst
+++ b/doc/guides/cryptodevs/openssl.rst
@@ -69,7 +69,7 @@ use version 1.1.1g or newer.
 Initialization
 --------------
 
-User can use app/test application to check how to use this pmd and to verify
+User can use app/test application to check how to use this PMD and to verify
 crypto processing.
 
 Test name is cryptodev_openssl_autotest.
diff --git a/doc/guides/cryptodevs/overview.rst b/doc/guides/cryptodevs/overview.rst
index 1172297915..d754b0cfc6 100644
--- a/doc/guides/cryptodevs/overview.rst
+++ b/doc/guides/cryptodevs/overview.rst
@@ -19,7 +19,7 @@ Supported Feature Flags
 
    - "OOP SGL In SGL Out" feature flag stands for
      "Out-of-place Scatter-gather list Input, Scatter-gather list Output",
-     which means pmd supports different scatter-gather styled input and output buffers
+     which means PMD supports different scatter-gather styled input and output buffers
      (i.e. both can consists of multiple segments).
 
    - "OOP SGL In LB Out" feature flag stands for
diff --git a/doc/guides/eventdevs/opdl.rst b/doc/guides/eventdevs/opdl.rst
index cbfd1f11b7..f220959249 100644
--- a/doc/guides/eventdevs/opdl.rst
+++ b/doc/guides/eventdevs/opdl.rst
@@ -87,7 +87,7 @@ due to the static nature of the underlying queues. It is because of this
 that the implementation can achieve such high throughput and low latency
 
 The following list is a comprehensive outline of the what is supported and
-the limitations / restrictions imposed by the opdl pmd
+the limitations / restrictions imposed by the opdl PMD
 
  - The order in which packets moved between queues is static and fixed \
    (dynamic scheduling is not supported).
diff --git a/doc/guides/nics/cnxk.rst b/doc/guides/nics/cnxk.rst
index 837ffc02b4..84f9865654 100644
--- a/doc/guides/nics/cnxk.rst
+++ b/doc/guides/nics/cnxk.rst
@@ -289,7 +289,7 @@ Limitations
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 The OCTEON CN9K/CN10K SoC family NIC has inbuilt HW assisted external mempool manager.
-``net_cnxk`` pmd only works with ``mempool_cnxk`` mempool handler
+``net_cnxk`` PMD only works with ``mempool_cnxk`` mempool handler
 as it is performance wise most effective way for packet allocation and Tx buffer
 recycling on OCTEON TX2 SoC platform.
 
diff --git a/doc/guides/nics/octeontx.rst b/doc/guides/nics/octeontx.rst
index 8236cc3e93..092120815d 100644
--- a/doc/guides/nics/octeontx.rst
+++ b/doc/guides/nics/octeontx.rst
@@ -108,7 +108,7 @@ for details.
 Initialization
 --------------
 
-The OCTEON TX ethdev pmd is exposed as a vdev device which consists of a set
+The OCTEON TX ethdev PMD is exposed as a vdev device which consists of a set
 of PKI and PKO PCIe VF devices. On EAL initialization,
 PKI/PKO PCIe VF devices will be probed and then the vdev device can be created
 from the application code, or from the EAL command line based on
@@ -126,7 +126,7 @@ the number of interesting ports with ``nr_ports`` argument.
 
 Dependency
 ~~~~~~~~~~
-``eth_octeontx`` pmd is depend on ``event_octeontx`` eventdev device and
+``eth_octeontx`` PMD is depend on ``event_octeontx`` eventdev device and
 ``octeontx_fpavf`` external mempool handler.
 
 Example:
diff --git a/doc/guides/nics/octeontx2.rst b/doc/guides/nics/octeontx2.rst
index eae32f0afe..4ce067f2c5 100644
--- a/doc/guides/nics/octeontx2.rst
+++ b/doc/guides/nics/octeontx2.rst
@@ -256,7 +256,7 @@ Limitations
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
 The OCTEON TX2 SoC family NIC has inbuilt HW assisted external mempool manager.
-``net_octeontx2`` pmd only works with ``mempool_octeontx2`` mempool handler
+``net_octeontx2`` PMD only works with ``mempool_octeontx2`` mempool handler
 as it is performance wise most effective way for packet allocation and Tx buffer
 recycling on OCTEON TX2 SoC platform.
 
@@ -269,7 +269,7 @@ the host interface irrespective of the offload configuration.
 Multicast MAC filtering
 ~~~~~~~~~~~~~~~~~~~~~~~
 
-``net_octeontx2`` pmd supports multicast mac filtering feature only on physical
+``net_octeontx2`` PMD supports multicast mac filtering feature only on physical
 function devices.
 
 SDP interface support
@@ -278,7 +278,7 @@ OCTEON TX2 SDP interface support is limited to PF device, No VF support.
 
 Inline Protocol Processing
 ~~~~~~~~~~~~~~~~~~~~~~~~~~
-``net_octeontx2`` pmd doesn't support the following features for packets to be
+``net_octeontx2`` PMD doesn't support the following features for packets to be
 inline protocol processed.
 - TSO offload
 - VLAN/QinQ offload
diff --git a/doc/guides/nics/thunderx.rst b/doc/guides/nics/thunderx.rst
index d96395dafa..5ae7e607de 100644
--- a/doc/guides/nics/thunderx.rst
+++ b/doc/guides/nics/thunderx.rst
@@ -371,7 +371,7 @@ Module params
 skip_data_bytes
 ~~~~~~~~~~~~~~~
 This feature is used to create a hole between HEADROOM and actual data. Size of hole is specified
-in bytes as module param("skip_data_bytes") to pmd.
+in bytes as module param("skip_data_bytes") to PMD.
 This scheme is useful when application would like to insert vlan header without disturbing HEADROOM.
 
 Example:
diff --git a/doc/guides/prog_guide/compressdev.rst b/doc/guides/prog_guide/compressdev.rst
index 231687d891..07d1a62a63 100644
--- a/doc/guides/prog_guide/compressdev.rst
+++ b/doc/guides/prog_guide/compressdev.rst
@@ -28,7 +28,7 @@ From the command line using the --vdev EAL option
 
 .. code-block:: console
 
-   --vdev  '<pmd name>,socket_id=0'
+   --vdev  '<PMD name>,socket_id=0'
 
 .. Note::
 
@@ -332,7 +332,7 @@ using priv_xform would look like:
      * pseudocode for stateless compression
      */
 
-    uint8_t cdev_id = rte_compressdev_get_dev_id(<pmd name>);
+    uint8_t cdev_id = rte_compressdev_get_dev_id(<PMD name>);
 
     /* configure the device. */
     if (rte_compressdev_configure(cdev_id, &conf) < 0)
@@ -475,7 +475,7 @@ An example pseudocode to set up and process a stream having NUM_CHUNKS with each
      * pseudocode for stateful compression
      */
 
-    uint8_t cdev_id = rte_compressdev_get_dev_id(<pmd name>);
+    uint8_t cdev_id = rte_compressdev_get_dev_id(<PMD name>);
 
     /* configure the  device. */
     if (rte_compressdev_configure(cdev_id, &conf) < 0)
diff --git a/doc/guides/rel_notes/release_18_02.rst b/doc/guides/rel_notes/release_18_02.rst
index 989017786b..af437e4153 100644
--- a/doc/guides/rel_notes/release_18_02.rst
+++ b/doc/guides/rel_notes/release_18_02.rst
@@ -105,9 +105,9 @@ New Features
   * ``VIRTIO_NET_F_GUEST_UFO``, ``VIRTIO_NET_F_HOST_UFO``
   * ``VIRTIO_NET_F_GSO``
 
-  Also added ``VIRTIO_NET_F_GUEST_ANNOUNCE`` feature support in virtio pmd.
+  Also added ``VIRTIO_NET_F_GUEST_ANNOUNCE`` feature support in virtio PMD.
   In a scenario where the vhost backend doesn't have the ability to generate
-  RARP packets, the VM running virtio pmd can still be live migrated if
+  RARP packets, the VM running virtio PMD can still be live migrated if
   ``VIRTIO_NET_F_GUEST_ANNOUNCE`` feature is negotiated.
 
 * **Updated the AESNI-MB PMD.**
diff --git a/doc/guides/rel_notes/release_2_1.rst b/doc/guides/rel_notes/release_2_1.rst
index 0c34458316..35e6c88884 100644
--- a/doc/guides/rel_notes/release_2_1.rst
+++ b/doc/guides/rel_notes/release_2_1.rst
@@ -242,7 +242,7 @@ New Features
 * **Added fm10k jumbo frame support.**
 
   Added support for jumbo frame less than 15K in both VF and PF functions in the
-  fm10k pmd.
+  fm10k PMD.
 
 
 * **Added fm10k mac vlan filtering support.**
diff --git a/doc/guides/sample_app_ug/vhost.rst b/doc/guides/sample_app_ug/vhost.rst
index 9afde9c7f5..a6ce4bc8ac 100644
--- a/doc/guides/sample_app_ug/vhost.rst
+++ b/doc/guides/sample_app_ug/vhost.rst
@@ -206,11 +206,11 @@ Common Issues
 * Option "builtin-net-driver" is incompatible with QEMU
 
   QEMU vhost net device start will fail if protocol feature is not negotiated.
-  DPDK virtio-user pmd can be the replacement of QEMU.
+  DPDK virtio-user PMD can be the replacement of QEMU.
 
 * Device start fails when enabling "builtin-net-driver" without memory
   pre-allocation
 
   The builtin example doesn't support dynamic memory allocation. When vhost
   backend enables "builtin-net-driver", "--socket-mem" option should be
-  added at virtio-user pmd side as a startup item.
+  added at virtio-user PMD side as a startup item.
diff --git a/doc/guides/vdpadevs/ifc.rst b/doc/guides/vdpadevs/ifc.rst
index f968489a75..706dbf740e 100644
--- a/doc/guides/vdpadevs/ifc.rst
+++ b/doc/guides/vdpadevs/ifc.rst
@@ -17,9 +17,9 @@ IFCVF vDPA Implementation
 IFCVF's vendor ID and device ID are same as that of virtio net pci device,
 with its specific subsystem vendor ID and device ID. To let the device be
 probed by IFCVF driver, adding "vdpa=1" parameter helps to specify that this
-device is to be used in vDPA mode, rather than polling mode, virtio pmd will
+device is to be used in vDPA mode, rather than polling mode, virtio PMD will
 skip when it detects this message. If no this parameter specified, device
-will not be used as a vDPA device, and it will be driven by virtio pmd.
+will not be used as a vDPA device, and it will be driven by virtio PMD.
 
 Different VF devices serve different virtio frontends which are in different
 VMs, so each VF needs to have its own DMA address translation service. During